'use babel';
'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _discordGraf = require('discord-graf');

var _commonTags = require('common-tags');

var _character = require('../../database/character');

var _character2 = _interopRequireDefault(_character);

var _config = require('../../config');

var _config2 = _interopRequireDefault(_config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

Function.prototype.$asyncbind = function $asyncbind(self, catcher) {
	var resolver = this;

	if (catcher === true) {
		if (!Function.prototype.$asyncbind.EagerThenable) Function.prototype.$asyncbind.EagerThenable = function factory(tick) {
			var _tasks = [];

			if (!tick) {
				try {
					tick = process.nextTick;
				} catch (ex) {
					tick = function tick(p) {
						setTimeout(p, 0);
					};
				}
			}

			function _untask() {
				for (var i = 0; i < _tasks.length; i += 2) {
					var t = _tasks[i + 1],
					    r = _tasks[i];

					for (var j = 0; j < t.length; j++) t[j].call(null, r);
				}

				_tasks = [];
			}

			function isThenable(obj) {
				return obj && obj instanceof Object && typeof obj.then === 'function';
			}

			function EagerThenable(resolver) {
				function done(inline) {
					var w;
					if (_sync || phase < 0 || (w = _thens[phase]).length === 0) return;

					_tasks.push(result, w);

					_thens = [[], []];
					if (_tasks.length === 2) inline ? _untask() : tick(_untask);
				}

				function resolveThen(x) {
					if (isThenable(x)) return x.then(resolveThen, rejectThen);
					phase = 0;
					result = x;
					done(true);
				}

				function rejectThen(x) {
					if (isThenable(x)) return x.then(resolveThen, rejectThen);
					phase = 1;
					result = x;
					done(true);
				}

				function settler(resolver, rejecter) {
					_thens[0].push(resolver);

					_thens[1].push(rejecter);

					done();
				}

				function toString() {
					return 'EagerThenable{' + {
						'-1': 'pending',
						0: 'resolved',
						1: 'rejected'
					}[phase] + '}=' + result.toString();
				}

				this.then = settler;
				this.toString = toString;
				var _thens = [[], []],
				    _sync = true,
				    phase = -1,
				    result;
				resolver.call(null, resolveThen, rejectThen);
				_sync = false;
				done();
			}

			EagerThenable.resolve = function (v) {
				return isThenable(v) ? v : {
					then: function then(resolve, reject) {
						return resolve(v);
					}
				};
			};

			return EagerThenable;
		}();
		return new Function.prototype.$asyncbind.EagerThenable(boundThen);
	}

	if (catcher) {
		if (Function.prototype.$asyncbind.wrapAsyncStack) catcher = Function.prototype.$asyncbind.wrapAsyncStack(catcher);
		return then;
	}

	function then(result, error) {
		try {
			return result && result instanceof Object && typeof result.then === 'function' ? result.then(then, catcher) : resolver.call(self, result, error || catcher);
		} catch (ex) {
			return (error || catcher)(ex);
		}
	}

	function boundThen(result, error) {
		return resolver.call(self, result, error);
	}

	boundThen.then = boundThen;
	return boundThen;
};

class ListCharactersCommand extends _discordGraf.Command {
	constructor(bot) {
		super(bot);
		this.name = 'characters';
		this.aliases = ['listcharacters', 'listchars', 'chars'];
		this.group = 'characters';
		this.groupName = 'list';
		this.description = 'Lists/searches characters in the database.';
		this.usage = 'characters [search] [page]';
		this.details = _commonTags.oneLine`
			If no search string is specified, all characters will be listed.
			If the search string is only one letter long, characters that start with that character will be listed.
			If the search string is more than one letter, all characters that contain that string will be listed.
			If the search string contains spaces, it must be surrounded by quotes.
		`;
		this.examples = ['characters', 'characters c', 'characters bill'];
		this.serverOnly = true;
		this.argsType = 'multiple';
	}

	run(message, args) {
		return new Promise(function ($return, $error) {
			var last, page, search, paginated;
			let characters;
			last = args.length >= 1 ? args.length - 1 : 0;
			page = !isNaN(args[last]) ? parseInt(args.pop()) : 1;
			search = args.join(' ');
			return _character2.default.findInServer(message.server, search, false).then(function ($await_1) {
				characters = $await_1;

				if (characters.length > 0) {
					characters.sort((a, b) => a.name < b.name ? -1 : a.name > b.name ? 1 : 0);
					paginated = this.bot.util.paginate(characters, page, Math.floor(_config2.default.paginationItems));

					characters = paginated.items;
					return $return(_commonTags.stripIndents`
				__**Character${ search ? `s ${ search.length === 1 ? 'that begin with' : 'that contain' } "${ search }"` : ' list' }, ${ paginated.pageText }:**__
				${ characters.map(char => `**-** ${ char.name }`).join('\n') }
				${ paginated.maxPage > 1 ? `\nUse ${ this.bot.util.usage(`characters ${ search ? `${ search } ` : '' }<page>`, message.server) } to view a specific page.` : '' }
				Use ${ this.bot.util.usage('character <name>', message.server) } to view information about a character.
			`);
				} else {
					return $return(`There are no characters ${ search ? `${ search.length === 1 ? 'that begin with' : 'that contain' } "${ search }"` : 'in the database' }.`);
				}
				return $return();
			}.$asyncbind(this, $error), $error);
		}.$asyncbind(this));
	}
}
exports.default = ListCharactersCommand;
//# sourceMappingURL=list.js.map
