'use babel';
'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _discordGraf = require('discord-graf');

var _character = require('../../database/character');

var _character2 = _interopRequireDefault(_character);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

Function.prototype.$asyncbind = function $asyncbind(self, catcher) {
	var resolver = this;

	if (catcher === true) {
		if (!Function.prototype.$asyncbind.EagerThenable) Function.prototype.$asyncbind.EagerThenable = function factory(tick) {
			var _tasks = [];

			if (!tick) {
				try {
					tick = process.nextTick;
				} catch (ex) {
					tick = function tick(p) {
						setTimeout(p, 0);
					};
				}
			}

			function _untask() {
				for (var i = 0; i < _tasks.length; i += 2) {
					var t = _tasks[i + 1],
					    r = _tasks[i];

					for (var j = 0; j < t.length; j++) t[j].call(null, r);
				}

				_tasks = [];
			}

			function isThenable(obj) {
				return obj && obj instanceof Object && typeof obj.then === 'function';
			}

			function EagerThenable(resolver) {
				function done(inline) {
					var w;
					if (_sync || phase < 0 || (w = _thens[phase]).length === 0) return;

					_tasks.push(result, w);

					_thens = [[], []];
					if (_tasks.length === 2) inline ? _untask() : tick(_untask);
				}

				function resolveThen(x) {
					if (isThenable(x)) return x.then(resolveThen, rejectThen);
					phase = 0;
					result = x;
					done(true);
				}

				function rejectThen(x) {
					if (isThenable(x)) return x.then(resolveThen, rejectThen);
					phase = 1;
					result = x;
					done(true);
				}

				function settler(resolver, rejecter) {
					_thens[0].push(resolver);

					_thens[1].push(rejecter);

					done();
				}

				function toString() {
					return 'EagerThenable{' + {
						'-1': 'pending',
						0: 'resolved',
						1: 'rejected'
					}[phase] + '}=' + result.toString();
				}

				this.then = settler;
				this.toString = toString;
				var _thens = [[], []],
				    _sync = true,
				    phase = -1,
				    result;
				resolver.call(null, resolveThen, rejectThen);
				_sync = false;
				done();
			}

			EagerThenable.resolve = function (v) {
				return isThenable(v) ? v : {
					then: function then(resolve, reject) {
						return resolve(v);
					}
				};
			};

			return EagerThenable;
		}();
		return new Function.prototype.$asyncbind.EagerThenable(boundThen);
	}

	if (catcher) {
		if (Function.prototype.$asyncbind.wrapAsyncStack) catcher = Function.prototype.$asyncbind.wrapAsyncStack(catcher);
		return then;
	}

	function then(result, error) {
		try {
			return result && result instanceof Object && typeof result.then === 'function' ? result.then(then, catcher) : resolver.call(self, result, error || catcher);
		} catch (ex) {
			return (error || catcher)(ex);
		}
	}

	function boundThen(result, error) {
		return resolver.call(self, result, error);
	}

	boundThen.then = boundThen;
	return boundThen;
};

class ViewCharacterCommand extends _discordGraf.Command {
	constructor(bot) {
		super(bot);
		this.name = 'character';
		this.aliases = ['viewcharacter', 'char'];
		this.group = 'characters';
		this.groupName = 'view';
		this.description = 'Views a character\'s information.';
		this.usage = 'character <name>';
		this.details = 'The name can be the whole name of the character, or just a part of it.';
		this.examples = ['character Billy McBillface', 'character bill'];
		this.serverOnly = true;
	}

	run(message, args) {
		return new Promise(function ($return, $error) {
			var characters, owner, ownerName;

			if (!args[0]) return $error(new _discordGraf.CommandFormatError(this, message.server));
			return _character2.default.findInServer(message.server, args[0]).then(function ($await_1) {
				characters = $await_1;

				if (characters.length === 1) {
					owner = message.client.users.get('id', characters[0].owner);
					ownerName = owner ? `${ owner.name }#${ owner.discriminator }` : 'Unknown';

					return $return(`Character **${ characters[0].name }** (created by ${ ownerName }):\n${ characters[0].info }`);
				} else if (characters.length > 1) {
					return $return(this.bot.util.disambiguation(characters, 'characters'));
				} else {
					return $return(`Unable to find character. Use ${ this.bot.util.usage('characters', message.server) } to view the list of characters.`);
				}
				return $return();
			}.$asyncbind(this, $error), $error);
		}.$asyncbind(this));
	}
}
exports.default = ViewCharacterCommand;
//# sourceMappingURL=view.js.map
