'use babel';
'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.config = undefined;

var _yargs = require('yargs');

var _yargs2 = _interopRequireDefault(_yargs);

var _bot = require('./bot');

var _bot2 = _interopRequireDefault(_bot);

var _version = require('./version');

var _version2 = _interopRequireDefault(_version);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

Function.prototype.$asyncbind = function $asyncbind(self, catcher) {
	var resolver = this;

	if (catcher === true) {
		if (!Function.prototype.$asyncbind.EagerThenable) Function.prototype.$asyncbind.EagerThenable = function factory(tick) {
			var _tasks = [];

			if (!tick) {
				try {
					tick = process.nextTick;
				} catch (ex) {
					tick = function tick(p) {
						setTimeout(p, 0);
					};
				}
			}

			function _untask() {
				for (var i = 0; i < _tasks.length; i += 2) {
					var t = _tasks[i + 1],
					    r = _tasks[i];

					for (var j = 0; j < t.length; j++) t[j].call(null, r);
				}

				_tasks = [];
			}

			function isThenable(obj) {
				return obj && obj instanceof Object && typeof obj.then === 'function';
			}

			function EagerThenable(resolver) {
				function done(inline) {
					var w;
					if (_sync || phase < 0 || (w = _thens[phase]).length === 0) return;

					_tasks.push(result, w);

					_thens = [[], []];
					if (_tasks.length === 2) inline ? _untask() : tick(_untask);
				}

				function resolveThen(x) {
					if (isThenable(x)) return x.then(resolveThen, rejectThen);
					phase = 0;
					result = x;
					done(true);
				}

				function rejectThen(x) {
					if (isThenable(x)) return x.then(resolveThen, rejectThen);
					phase = 1;
					result = x;
					done(true);
				}

				function settler(resolver, rejecter) {
					_thens[0].push(resolver);

					_thens[1].push(rejecter);

					done();
				}

				function toString() {
					return 'EagerThenable{' + {
						'-1': 'pending',
						0: 'resolved',
						1: 'rejected'
					}[phase] + '}=' + result.toString();
				}

				this.then = settler;
				this.toString = toString;
				var _thens = [[], []],
				    _sync = true,
				    phase = -1,
				    result;
				resolver.call(null, resolveThen, rejectThen);
				_sync = false;
				done();
			}

			EagerThenable.resolve = function (v) {
				return isThenable(v) ? v : {
					then: function then(resolve, reject) {
						return resolve(v);
					}
				};
			};

			return EagerThenable;
		}();
		return new Function.prototype.$asyncbind.EagerThenable(boundThen);
	}

	if (catcher) {
		if (Function.prototype.$asyncbind.wrapAsyncStack) catcher = Function.prototype.$asyncbind.wrapAsyncStack(catcher);
		return then;
	}

	function then(result, error) {
		try {
			return result && result instanceof Object && typeof result.then === 'function' ? result.then(then, catcher) : resolver.call(self, result, error || catcher);
		} catch (ex) {
			return (error || catcher)(ex);
		}
	}

	function boundThen(result, error) {
		return resolver.call(self, result, error);
	}

	boundThen.then = boundThen;
	return boundThen;
};

_bot2.default.config.defaults.log = 'rpbot.log';
_bot2.default.config.defaults.storage = 'rpbot-storage';
_bot2.default.config.loadDefaults();

const config = exports.config = _bot2.default.config.yargs(_yargs2.default).usage('$0 [command] [options]').example('$0 --token SomeAPITokenGoesHere', 'Starts the bot using a token').example('$0 --email SomeGuy@SomeSite.com --password SomeCrazyPassword123', 'Starts the bot using an email and password').example('$0 --config settings.yml', 'Starts the bot using a config file').example('$0 completion', 'Outputs Bash completion script').epilogue(`RPBot v${ _version2.default } by Schuyler Cebulskie (Gawdl3y): https://github.com/Gawdl3y/discord-rpbot/`)

// Database
.option('database', {
	type: 'string',
	default: 'rpbot.sqlite3',
	alias: 'd',
	describe: 'Path to SQLite3 database file',
	group: 'Database:',
	normalize: true
}).option('database-verbose', {
	type: 'boolean',
	alias: 'V',
	describe: 'Whether or not SQLite3 should be put into verbose mode',
	group: 'Database:'
})

// General
.option('analytics', {
	type: 'boolean',
	default: true,
	alias: 'A',
	describe: 'Whether or not to enable anonymous, non-unique, non-identifiable analytics',
	group: 'General:'
})

// General yargs
.help().alias('help', 'h').group('help', 'Special:').version(_version2.default).alias('version', 'v').group('version', 'Special:').completion('completion').wrap(_yargs2.default.terminalWidth()).argv;
exports.default = config;
//# sourceMappingURL=config.js.map
