#!/usr/bin/env node

'use babel';
'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.client = undefined;

var _bot = require('./bot');

var _bot2 = _interopRequireDefault(_bot);

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

var _version = require('./version');

var _version2 = _interopRequireDefault(_version);

var _database = require('./database');

var _analytics = require('./util/analytics');

var analytics = _interopRequireWildcard(_analytics);

var _list = require('./commands/characters/list');

var _list2 = _interopRequireDefault(_list);

var _view = require('./commands/characters/view');

var _view2 = _interopRequireDefault(_view);

var _add = require('./commands/characters/add');

var _add2 = _interopRequireDefault(_add);

var _delete = require('./commands/characters/delete');

var _delete2 = _interopRequireDefault(_delete);

var _clear = require('./commands/characters/clear');

var _clear2 = _interopRequireDefault(_clear);

var _roll = require('./commands/dice/roll');

var _roll2 = _interopRequireDefault(_roll);

var _max = require('./commands/dice/max');

var _max2 = _interopRequireDefault(_max);

var _min = require('./commands/dice/min');

var _min2 = _interopRequireDefault(_min);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

Function.prototype.$asyncbind = function $asyncbind(self, catcher) {
	var resolver = this;

	if (catcher === true) {
		if (!Function.prototype.$asyncbind.EagerThenable) Function.prototype.$asyncbind.EagerThenable = function factory(tick) {
			var _tasks = [];

			if (!tick) {
				try {
					tick = process.nextTick;
				} catch (ex) {
					tick = function tick(p) {
						setTimeout(p, 0);
					};
				}
			}

			function _untask() {
				for (var i = 0; i < _tasks.length; i += 2) {
					var t = _tasks[i + 1],
					    r = _tasks[i];

					for (var j = 0; j < t.length; j++) t[j].call(null, r);
				}

				_tasks = [];
			}

			function isThenable(obj) {
				return obj && obj instanceof Object && typeof obj.then === 'function';
			}

			function EagerThenable(resolver) {
				function done(inline) {
					var w;
					if (_sync || phase < 0 || (w = _thens[phase]).length === 0) return;

					_tasks.push(result, w);

					_thens = [[], []];
					if (_tasks.length === 2) inline ? _untask() : tick(_untask);
				}

				function resolveThen(x) {
					if (isThenable(x)) return x.then(resolveThen, rejectThen);
					phase = 0;
					result = x;
					done(true);
				}

				function rejectThen(x) {
					if (isThenable(x)) return x.then(resolveThen, rejectThen);
					phase = 1;
					result = x;
					done(true);
				}

				function settler(resolver, rejecter) {
					_thens[0].push(resolver);

					_thens[1].push(rejecter);

					done();
				}

				function toString() {
					return 'EagerThenable{' + {
						'-1': 'pending',
						0: 'resolved',
						1: 'rejected'
					}[phase] + '}=' + result.toString();
				}

				this.then = settler;
				this.toString = toString;
				var _thens = [[], []],
				    _sync = true,
				    phase = -1,
				    result;
				resolver.call(null, resolveThen, rejectThen);
				_sync = false;
				done();
			}

			EagerThenable.resolve = function (v) {
				return isThenable(v) ? v : {
					then: function then(resolve, reject) {
						return resolve(v);
					}
				};
			};

			return EagerThenable;
		}();
		return new Function.prototype.$asyncbind.EagerThenable(boundThen);
	}

	if (catcher) {
		if (Function.prototype.$asyncbind.wrapAsyncStack) catcher = Function.prototype.$asyncbind.wrapAsyncStack(catcher);
		return then;
	}

	function then(result, error) {
		try {
			return result && result instanceof Object && typeof result.then === 'function' ? result.then(then, catcher) : resolver.call(self, result, error || catcher);
		} catch (ex) {
			return (error || catcher)(ex);
		}
	}

	function boundThen(result, error) {
		return resolver.call(self, result, error);
	}

	boundThen.then = boundThen;
	return boundThen;
}; // eslint-disable-line no-unused-vars


_bot2.default.logger.info(`RPBot v${ _version2.default } is starting...`);
analytics.sendEvent('Bot', 'started');

// Create bot
const client = exports.client = _bot2.default.createClient();
_bot2.default.registerDefaultCommands();
_bot2.default.registerCommands([_list2.default, _view2.default, _add2.default, _delete2.default, _clear2.default, _roll2.default, _max2.default, _min2.default]);
_bot2.default.nameGroups([['characters', 'Characters'], ['dice', 'Dice']]);

// Set up database
(0, _database.init)().catch(err => {
	_bot2.default.logger.error(err);
	process.exit(1);
});

// Exit on interrupt
let interruptCount = 0;
process.on('SIGINT', () => {
	return new Promise(function ($return, $error) {
		interruptCount++;

		function $IfStatement_1() {
			return $return();
		}

		if (interruptCount === 1) {
			_bot2.default.logger.info('Received interrupt signal; closing database, destroying client, and exiting...');
			return Promise.all([(0, _database.close)(), client.destroy()]).catch(err => {
				_bot2.default.logger.error(err);
			}).then(function ($await_2) {
				process.exit(0);
				return $IfStatement_1.call(this);
			}.$asyncbind(this, $error), $error);
		} else {
			_bot2.default.logger.info('Received another interrupt signal; immediately exiting.');
			process.exit(0);
			return $IfStatement_1.call(this);
		}
	}.$asyncbind(undefined));
});
//# sourceMappingURL=rpbot.js.map
